# Autogenerated wrapper script for GSL_jll for x86_64-unknown-freebsd11.1
export libgsl

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libgsl`
const libgsl_splitpath = ["lib", "libgsl.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libgsl_path = ""

# libgsl-specific global declaration
# This will be filled out by __init__()
libgsl_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libgsl = "libgsl.so.25"


"""
Open all libraries
"""
function __init__()
    global prefix = abspath(joinpath(@__DIR__, ".."))

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    global libgsl_path = abspath(joinpath(artifact"GSL", libgsl_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libgsl_handle = dlopen(libgsl_path)
    push!(LIBPATH_list, dirname(libgsl_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

